summaryrefslogtreecommitdiff
path: root/t/lex-noyywrap.sh
diff options
context:
space:
mode:
Diffstat (limited to 't/lex-noyywrap.sh')
-rwxr-xr-xt/lex-noyywrap.sh75
1 files changed, 75 insertions, 0 deletions
diff --git a/t/lex-noyywrap.sh b/t/lex-noyywrap.sh
new file mode 100755
index 000000000..1c4a13b19
--- /dev/null
+++ b/t/lex-noyywrap.sh
@@ -0,0 +1,75 @@
+#! /bin/sh
+# Copyright (C) 1999-2012 Free Software Foundation, Inc.
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2, or (at your option)
+# any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+# Check Lex support with flex using the '%noyywrap' option.
+
+required='cc flex'
+. ./defs || Exit 1
+
+cat >> configure.ac << 'END'
+AC_PROG_CC
+AM_PROG_LEX
+AC_OUTPUT
+END
+
+cat > Makefile.am << 'END'
+bin_PROGRAMS = foo
+foo_SOURCES = foo.l
+
+.PHONY: test-no-lexlib
+check-local: test-no-lexlib
+test-no-lexlib:
+ test x'$(LEXLIB)' = x'none needed'
+END
+
+cat > foo.l << 'END'
+%option noyywrap
+%{
+#define YY_NO_UNISTD_H 1
+%}
+%%
+"GOOD" return EOF;
+.
+%%
+int main (void)
+{
+ /* We don't use a 'while' loop here (like a real lexer would do)
+ to avoid possible hangs. */
+ if (yylex () == EOF)
+ return 0;
+ else
+ return 1;
+}
+END
+
+$ACLOCAL
+$AUTOCONF
+$AUTOMAKE -a
+
+./configure LEXLIB="none needed"
+
+# Program should build and run.
+$MAKE
+if cross_compiling; then :; else
+ echo GOOD | ./foo
+ echo BAD | ./foo && Exit 1
+ : For shells with busted 'set -e'.
+fi
+
+# Sanity check on distribution.
+yl_distcheck DISTCHECK_CONFIGURE_FLAGS='LEXLIB="none needed"'
+
+: